# fastscore.schema.0: double
# fastscore.schema.2: adjustment
# fastscore.schema.1: double

def begin():
    global adjustments, predictions, input_count, input_threshold
    adjustments = []
    predictions = []
    input_count = 0
    input_threshold = 30

def action(data, slot):
    global adjustments, predictions, input_count, input_threshold
    input_count += 1

    if slot == 0:
        predictions.append(data)
    if slot == 2 and input_count >= input_threshold:
        adjustments.append(data)

    while len(adjustments) > 0 and len(predictions) > 0:
        adjust = adjustments[0]
        pred = predictions[0]
        adjustments = adjustments[1:]
        predictions = predictions[1:]

        lr = adjust['LR']
        cpi = adjust['CPI']

        yield cpi*(pred + lr)
